>

Definieren wir nun einen Datentyp f"ur die instruktionen der
$G^\#$-Maschine.\index{G-Maschine@@$G^\#$-Maschine!Anweisungen}

> module InstrType(Instruction(..), Name(..), AssocList(..)) where
> import AbsSyntax(Name(..))
> import Utils(AssocList(..))

Viele der Instruktionen der $G^\#$-Maschine stammen von der
G-Maschine.\index{G-Maschine!Anweisungen} 

> data Instruction 
>   = Unwind
>   | Pushglobal Name
>   | Pushint Int
>   | Push Int
>   | Mkap
>   | Update Int
>   | Pop Int
>   | Alloc Int
>   | Slide Int
>   | Eval
>   | Add | Sub | Mul | Div | Neg
>   | Eq | Ne | Lt | Le | Gt | Ge
>   | Pack Int Int
>   | Casejump (AssocList Int [Instruction])
>   | Split Int
>   | Print
>   | Ord
>   | Chr

Es gibt in der $G^\#$-Maschine
\index{G-Maschine@@$G^\#$-Maschine!Anweisungen} Instruktionen, f"ur die
die G-Maschine keinen Bedarf hat. Dies sind:

\begin{itemize}

\item Die @Join@ Anweisung kann mehrere alternative
Ableitungsfolgen zusammen\-f"uhren.

>   | Join

\item Um abstrakte Werte miteinander vergleichen zu k"onnen,
hat die $G^\#$-Ma\-schi\-ne die @AbsEq@ Anweisung.

>   | AbsEq

\item Schlie"slich hat die $G^\#$-Maschine eine Instruktion um
aus $n$ Knoten eine $n$-elementige Vereinigung zu machen.

>   | MkUnion Int

\item An instruction to add the top stack entry to the list of marked roots

>   | Mark

\end{itemize}

Gelegentlich m"ussen Anweisungen miteinander verglichen werden,
dazu machen wir aus dem Typ @Instruction@ eine Instanz der
Klasse @Eq@.

> instance Eq Instruction 
>   where
>   Unwind      == Unwind       = True
>   Pushglobal a== Pushglobal b = a == b
>   Pushint a   == Pushint b    = a == b
>   Push a      == Push b       = a == b
>   Mkap        == Mkap         = True
>   Update a    == Update b     = a == b
>   Pop a       == Pop b        = a == b
>   Alloc a     == Alloc b      = a == b
>   Slide a     == Slide b      = a == b
>   Eval        == Eval         = True
>   Add         == Add          = True
>   Sub         == Sub          = True
>   Mul         == Mul          = True
>   Div         == Div          = True
>   Neg         == Neg          = True
>   Eq          == Eq           = True
>   Ne          == Ne           = True
>   Lt          == Lt           = True
>   Le          == Le           = True
>   Gt          == Gt           = True
>   Ge          == Ge           = True
>   Pack a b    == Pack c d     = a == c && b == d
>   Casejump a  == Casejump b   = a == b
>   Split a     == Split b      = a == b
>   Print       == Print        = True
>   Ord         == Ord          = True
>   Chr         == Chr          = True
>   Join        == Join     = True
>   AbsEq       == AbsEq        = True
>   MkUnion a   == MkUnion b    = a == b
>   Mark        == Mark         = True
>   _           == _            = False

%file ends here

