>

> module LessEqual where
> import StateType

Die Vereinigungen\index{Vereinigung} m"ussen f"ur @lessEqual@ bereits
vereinfacht\index{vereinfachte Vereinigung} 
sein.

The @lessEqual@ function approximates the $\le_\alpha$ relation on
abstract graphs. It is used for simplification of unions and for path
analysis. For the upper one we can use the reduced {\em or} the
original redex.

> lessEqual :: GmHeap -> Node -> Node -> [(Node, Node)] -> Bool
> lessEqual _   NBot     _    _ = True
> lessEqual _   _    NTop _ = True
> lessEqual hp  (NInd a) b  p   
>   = a' == b || lessEqual hp a' b p
>   where   a' = rLookup hp a
> lessEqual hp  a    (NInd b) p 
>   = a == b' || lessEqual hp a b' p
>   where   
>   b' = oLookup hp b

\par

> lessEqual hp  x@(NAp d e) y@(NAp f g) p =
>   (d == f || lessEqual hp (llook d) (ulook f) p'
>   )
>   && (e == g || lessEqual hp (llook e) (ulook g) p'
>   )
>   where   
>   p' = (x, y) : p
>   llook = rLookup hp
>   ulook = oLookup hp

\par

> lessEqual hp a@(NConstr t f)  b@(NConstr u g) p = 
>   t == u 
>   && all (\ (x, y) -> lessEqual hp (llook x) (ulook y) p' 
>   ) (zip f g)
>   where   
>   p' = (a, b) : p
>   llook = rLookup hp
>   ulook = oLookup hp

\par

> lessEqual hp  t       y@(NUnion us)   p = or (map leq us)
>   where 
>   p' = (t, y) : p
>   ulook = oLookup hp
>   leq x = lessEqual hp t (ulook x) p'

\par

> lessEqual hp  (NUnion us) t'      p =
>   all (\ x -> lessEqual hp (llook x) t' p) us
>   where llook = rLookup hp

\par

> lessEqual _   t   t'  p = t == t' || elem (t, t') p


% this file ends here

