
module Main where
import Impl (allNames, strictPosition,
              callGraph, callGraphSCCs,
              CallGraphEdge(..), analyseFunctions,
              analyserStartStates, CallGraph(..), SCC(..))
import Compiler
import Evaluator
import Show
import IO (progArgs)
import StateType
import AbsSyntax

main :: Dialogue
main ~(r3 :_) =
 [ReadFile (head progArgs),
   AppendChan stdout 
      (case r3 of
          Str contents -> 
              let initialState = compile (parse contents)
                  e = last (eval (head a))
                  a = analyserStartStates initialState "until" 2
                  hp = getHeap e
              in
                  (show (not (resourcesExhausted e))) ++ "\n" ++
                  (show (neq hp (rLookup hp (head (getStack e))) NBot)) ++
                  "\n" ++ (show (getStack e)) ++ "\n" ++
                  (iDisplay (showStack e)) ++ "\n" ++
                  (show (strictPosition a))
          Failure    _ -> "Can't open " ++ (head progArgs))]

