>

Dieser Anhang enth"alt einige wesentliche Teile des Programms zur
Striktheits-Analyse. Der vollst"andige Programmtext ist auf Wunsch vom
Autor, unter der auf der Titelseite erw"ahnten Adresse, erh"altlich. 
Die Module, die nicht abgedruckt wurden, beziehen sich auf den
Lexer, den Compiler, die Hilfsfunktionen  und die Funktionen zur
Ausgabe der Ergebnisse.

Von der @main@-Funktion werden alle
Superkombinatoren einer Datei analysiert. In der Gofer Version
fragt sie den Anwender nach einem Namen, in der Haskell Version wird
das Kommandozeilenargument verwendet. In beiden Versionen wird dann
die Datei gelesen und die enthaltenen Superkombinatoren werden analysiert.

> module Main where
> import Impl (allNames, strictPosition,
>               analyseFunctions,
>               analyserStartStates)
> import Compiler
> import Evaluator
> import Show
> import Utils

 import IO

> import StateType
> import AbsSyntax

\par

> main :: Dialogue
> main ~(StrList progArgs : ~(r3 :_)) =
>  [
>   GetArgs,
>    ReadFile name,
>    AppendChan stdout 
>       (case r3 of
>           Str contents -> 
>               let initialState = 
>                       putOpenTermLimit (convert depth) (compile (parse contents))
>               in
>                   (showAnalyserResults [analyseFunctions 
>                    (allNames initialState)
>                    initialState]) ++ "\n"
>           Failure _ -> "Can't open " ++ name)]
>   where 
>      (depth : name :_) = progArgs
>
> convert :: String -> Int
> convert ss = foldl multadd 0 [(ord s) - (ord '0') | s <- ss]
>   where multadd z x = z*10+x

% file ends here







